package ru.dbotthepony.mc.otm.android;

import net.minecraft.nbt.CompoundTag;
import net.minecraftforge.common.util.INBTSerializable;
import ru.dbotthepony.mc.otm.capability.IAndroidCapability;

public class AndroidFeature implements INBTSerializable<CompoundTag> {
	public final AndroidFeatureType<? extends AndroidFeature> type;
	public final IAndroidCapability capability;

	protected int level = 0;

	public AndroidFeature(AndroidFeatureType<?> type, IAndroidCapability capability) {
		this.type = type;
		this.capability = capability;
	}

	public void setLevel(int level) {
		if (this.level != level) {
			this.level = level;
			applyModifiers();
		}
	}

	public int getLevel() {
		return level;
	}

	@Override
	public boolean equals(Object obj) {
		if (super.equals(obj))
			return true;

		if (obj instanceof AndroidFeature feature)
			return feature.type.equals(type);

		return false;
	}

	public void invalidateNetwork() {
		// when player forgets everything
	}

	@Override
	public int hashCode() {
		return type.hashCode();
	}

	public void tickClient() {

	}

	public void tickServer() {

	}

	public void applyModifiers() {}
	public void removeModifiers() {}

	public void serializeNBT(CompoundTag tag) {
		tag.putInt("level", level);
	}

	@Override
	public CompoundTag serializeNBT() {
		var tag = new CompoundTag();
		serializeNBT(tag);
		return tag;
	}

	@Override
	public void deserializeNBT(CompoundTag tag) {
		level = tag.getInt("level");
	}
}
