package ru.dbotthepony.mc.otm.android;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraftforge.registries.ForgeRegistryEntry;
import ru.dbotthepony.mc.otm.capability.AndroidCapabilityPlayer;

public class AndroidResearchType<T extends AndroidResearch> extends ForgeRegistryEntry<AndroidResearchType<?>> {
	public interface AndroidResearchFactory<T extends AndroidResearch> {
		T factory(AndroidResearchType<T> entry, AndroidCapabilityPlayer capability);
	}

	protected final AndroidResearchFactory<T> factory;

	public AndroidResearchType(AndroidResearchFactory<T> factory) {
		this.factory = factory;
	}

	public T factory(AndroidCapabilityPlayer capability) {
		return factory.factory(this, capability);
	}

	public Component getDisplayName() {
		if (getRegistryName() == null)
			return new TranslatableComponent("android_research.null.null");

		return new TranslatableComponent("android_research." + getRegistryName().getNamespace() + "." + getRegistryName().getPath());
	}
}
