package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.fmllegacy.network.NetworkEvent;
import ru.dbotthepony.mc.otm.capability.PatternState;
import ru.dbotthepony.mc.otm.menu.MatterPanelMenu;

import java.util.function.Supplier;

public record PatternReplicationRequestPacket(PatternState state, int how_much) {
	public PatternReplicationRequestPacket(PatternState state, int how_much) {
		this.state = state;
		this.how_much = Math.max(1, Math.min(99999, how_much));
	}

	public void write(FriendlyByteBuf buffer) {
		state.write(buffer);
		buffer.writeInt(how_much);
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);

		context.get().enqueueWork(() -> {
			if (state == null)
				return;

			var ply = context.get().getSender();

			if (ply.containerMenu instanceof MatterPanelMenu menu)
				menu.requestReplication(ply, state, how_much);
		});
	}

	public static PatternReplicationRequestPacket read(FriendlyByteBuf buffer) {
		return new PatternReplicationRequestPacket(PatternState.read(buffer), buffer.readInt());
	}
}
