package ru.dbotthepony.mc.otm.screen.panels;

import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class GridPanel extends EditablePanel {
	protected int grid_width;
	protected int grid_height;

	public GridPanel(
		@Nonnull MatteryScreen<?> screen,
		@Nullable EditablePanel parent,
		float x,
		float y,
		float width,
		float height,
		int grid_width,
		int grid_height
	) {
		super(screen, parent, x, y, width, height);
		this.grid_width = grid_width;
		this.grid_height = grid_height;
	}

	@Override
	protected void performLayout() {
		super.performLayout();

		float current_x = 0;
		float current_y = 0;
		float line_y = 0;

		int index = 0;

		for (int row = 0; row < grid_height; row++) {
			for (int column = 0; column < grid_width; column++) {
				var child = childAtIndex(index);

				if (child == null) {
					break;
				}

				if (child.getVisible()) {
					line_y = Math.max(line_y, child.getHeight() + child.getDockMargin().top() + child.getDockMargin().bottom());
					child.setPos(current_x + child.getDockMargin().left(), current_y + child.getDockMargin().top());
					current_x += child.getWidth() + child.getDockMargin().left() + child.getDockMargin().right();
				} else {
					column--;
				}

				index++;
			}

			current_y += line_y;
			current_x = 0;
			line_y = 0;

			if (childAtIndex(index) == null) {
				break;
			}
		}
	}
}
